// JNMM4LPXTDIOFunctions.c : Defines the entry point for the console application.
//

#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>
#include <sys/select.h>
#include <termios.h>
#include <stropts.h>
#include <unistd.h>



#include "../CANLib/libcan.h"

#define MAX_CAN 4
int fd[MAX_CAN];

CANCONFIG canconfig;


unsigned int base_address = 0x7000;



char dio_buffer[20];


int main()
{
	
	int can_fd;
	char input_buffer[20];
	
	int flag;
	printf ( "\nDSCJNMMCAN4LP-XT FPGA Version Application \n" );
	unsigned short FPGA_Ver,board_ver;

	can_fd = JNMMCANOpen(&flag);
	if(can_fd == -1)
	{
		return 0;
	}
	if(flag==isa_mode)
	{
	  	printf ( "Enter the base address ( 0xE000,0x1000,0x2000,0x3000,0x4000,0x5000,0x6000,default 0x7000  , hit ENTER ) : " );
		fgets ( input_buffer, 20, stdin );

		if ( input_buffer[0] == '\n' )
		{
			printf("base address default with 0x7000  \n");
		}
		else
		{
			sscanf( input_buffer, "%x", &base_address );
		}
		JNMMCANBaseAddrInit(base_address);
	}
	else
	  	printf("\nDSC-JNMM-CAN4LP-XT-PCI Device\n");
	
	
	FPGA_Ver = JNMMGetFPGAVersion();
	printf("JNMMCAN4LP-XT FPGA Version is 0x%x \n",FPGA_Ver);

	board_ver = JNMMGetBoardVersion();
	printf("JNMMCAN4LP-XT Board Version is 0x%x \n",board_ver);
	
	JNMMCANClose(can_fd);	
	
	
	printf ( "\nDSCJNMMCAN4LP-XT FPGA Version Application Closed\n" );
	return 0;
}

